package net.vision_design.loginapp;

import android.graphics.Color;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.content.Intent;
import android.os.AsyncTask;
import android.preference.PreferenceManager;
import android.support.v4.app.Fragment;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.Gravity;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

import android.content.SharedPreferences;
import android.os.Bundle;
import java.text.SimpleDateFormat;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.util.Calendar;
import java.util.Date;
import java.util.Iterator;

public class FourthFragment extends Fragment{
    int current_year = 0;
    static int year = 0;  // used to track year with previous/next button
    String user_id;
    String ini_year;
    JSONArray jArray = null;
    String url = "http://xelf.ca/registration/getSummary.php";

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {

        View rootView = inflater.inflate(R.layout.fourth_fragment, container, false);

        Button sum_previous = (Button) rootView.findViewById(R.id.sum_previous);
        sum_previous.setOnClickListener(sum_previous_Listener);

        Button sum_next = (Button) rootView.findViewById(R.id.sum_next);
        sum_next.setOnClickListener(sum_next_Listener);

        return rootView;
    }

    @Override
    public void onActivityCreated(Bundle savedInstanceState) {
        super.onActivityCreated(savedInstanceState);

        Calendar cal = Calendar.getInstance();
        //cal.setTime(date);
        ini_year = String.valueOf(cal.get(Calendar.YEAR));

        //final GlobalUserid globalUserid = (GlobalUserid) getActivity().getApplicationContext();
        //user_id  = String.valueOf(globalUserid.getUserid());
        user_id = SaveSharedPreference.getUserId(FourthFragment.super.getContext());

        Calendar now = Calendar.getInstance();
        year = now.get(Calendar.YEAR);
        current_year = year;

        EditText y = (EditText) getView().findViewById(R.id.sum_year);
        CharSequence yearcs = Integer.toString(year);
        y.setText(yearcs);

        GetSummary getSummary = new GetSummary();
        String r = "Hello";
        try {
            r = getSummary.execute(url, user_id, ini_year).get();
        }catch (Exception e){

        }
        setSummary(r, String.valueOf(year));

    }

    private View.OnClickListener sum_next_Listener = new View.OnClickListener() {
        public void onClick(View v) {
            year++;
            Fragment ff = new FourthFragment();
            ff.getView();

            if (year - current_year == 2) {
                Button next = (Button) getView().findViewById(R.id.sum_next);
                next.setEnabled(false);
            }
            if (current_year - year < 2) {
                Button previous = (Button) getView().findViewById(R.id.sum_previous);
                previous.setEnabled(true);
            }

            GetSummary getSummary = new GetSummary();
            String r = "Hello";
            try {
                r = getSummary.execute(url, user_id, String.valueOf(year)).get();
            }catch (Exception e){

            }
            setSummary(r, String.valueOf(year));
        }
    };

    private View.OnClickListener sum_previous_Listener = new View.OnClickListener() {
        public void onClick(View v) {
            year--;
            Fragment ff = new FourthFragment();
            ff.getView();

            if (current_year - year == 2) {
                Button previous = (Button) getView().findViewById(R.id.sum_previous);
                previous.setEnabled(false);
            }
            if (year - current_year < 2) {
                Button next = (Button) getView().findViewById(R.id.sum_next);
                next.setEnabled(true);
            }

            GetSummary getSummary = new GetSummary();
            String r = "Hello";
            try {
                r = getSummary.execute(url, user_id, String.valueOf(year)).get();
            }catch (Exception e){

            }
            setSummary(r, String.valueOf(year));
        }
    };

    public class GetSummary extends AsyncTask<String, Void, String> {

        protected void onPreExecute() {
        }

        @Override
        protected String doInBackground(String... params) {
            try {
                URL url = new URL(params[0]);
                JSONObject postDataParams = new JSONObject();
                postDataParams.put("userid", params[1]);
                postDataParams.put("year", params[2]);
                Log.e("params", postDataParams.toString());

                HttpURLConnection conn = (HttpURLConnection) url.openConnection();
                conn.setReadTimeout(3500);
                conn.setConnectTimeout(3500);  /* milliseconds */
                conn.setRequestMethod("POST");
                conn.setDoInput(true);
                conn.setDoOutput(true);

                OutputStream os = conn.getOutputStream();
                BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(os, "UTF-8"));
                writer.write(getPostDataString(postDataParams));

                writer.flush();
                writer.close();
                os.close();

                int responseCode = conn.getResponseCode();

                if (responseCode == HttpURLConnection.HTTP_OK) {

                    BufferedReader in = new BufferedReader(
                            new InputStreamReader(
                                    conn.getInputStream()));
                    StringBuffer sb = new StringBuffer("");
                    String line = "";

                    while ((line = in.readLine()) != null) {

                        sb.append(line);
                        break;
                    }

                    in.close();
                    return sb.toString();

                } else {
                    return new String("false : " + responseCode);
                }
            } catch (Exception e) {
                return new String("Exception: " + e.getMessage());
            }

        }

        @Override
        protected void onPostExecute(String result) {

        }

        public String getPostDataString(JSONObject params) throws Exception {

            StringBuilder result = new StringBuilder();
            boolean first = true;

            Iterator<String> itr = params.keys();

            while (itr.hasNext()) {

                String key = itr.next();
                Object value = params.get(key);

                if (first)
                    first = false;
                else
                    result.append("&");

                result.append(URLEncoder.encode(key, "UTF-8"));
                result.append("=");
                result.append(URLEncoder.encode(value.toString(), "UTF-8"));

            }
            return result.toString();
        }
    }

    public void setSummary(String r, String year){
        JSONObject jsonObj = null;
        try {
            EditText sum_year = (EditText) getView().findViewById(R.id.sum_year);
            sum_year.setText(year);

            jsonObj = new JSONObject(r);
            jArray = jsonObj.getJSONArray("result");
            //January
            JSONObject json_data = jArray.getJSONObject(0);

            String g_rt = json_data.getString("g_rt");
            String g_pa = json_data.getString("g_pa");
            String e_rt = json_data.getString("e_rt");
            String e_pa = json_data.getString("e_pa");

            TextView sum_rt_1 = (TextView) getView().findViewById(R.id.sum_rt_1);
            sum_rt_1.setText(g_rt + "/" + g_pa);
            TextView sum_pa_1 = (TextView) getView().findViewById(R.id.sum_pa_1);
            sum_pa_1.setText(e_rt + "/" + e_pa);
            if (Integer.parseInt(e_rt) < Integer.parseInt(g_rt) && Integer.parseInt(e_pa) < Integer.parseInt(g_pa)){
                sum_pa_1.setTextColor(Color.RED);
            }else if (Integer.parseInt(e_rt) < Integer.parseInt(g_rt) || Integer.parseInt(e_pa) < Integer.parseInt(g_pa)) {
                sum_pa_1.setTextColor(Color.parseColor("#FFA500"));
            }else if (Integer.parseInt(e_rt) > Integer.parseInt(g_rt) && Integer.parseInt(e_pa) > Integer.parseInt(g_pa)){
                sum_pa_1.setTextColor(Color.GREEN);
            }
            //Feburary
            json_data = jArray.getJSONObject(1);

            g_rt = json_data.getString("g_rt");
            g_pa = json_data.getString("g_pa");
            e_rt = json_data.getString("e_rt");
            e_pa = json_data.getString("e_pa");

            TextView sum_rt_2 = (TextView) getView().findViewById(R.id.sum_rt_2);
            sum_rt_2.setText(g_rt + "/" + g_pa);
            TextView sum_pa_2 = (TextView) getView().findViewById(R.id.sum_pa_2);
            sum_pa_2.setText(e_rt + "/" + e_pa);
            if (Integer.parseInt(e_rt) < Integer.parseInt(g_rt) && Integer.parseInt(e_pa) < Integer.parseInt(g_pa)){
                sum_pa_2.setTextColor(Color.RED);
            }else if (Integer.parseInt(e_rt) < Integer.parseInt(g_rt) || Integer.parseInt(e_pa) < Integer.parseInt(g_pa)) {
                sum_pa_2.setTextColor(Color.parseColor("#FFA500"));
            }else if (Integer.parseInt(e_rt) > Integer.parseInt(g_rt) && Integer.parseInt(e_pa) > Integer.parseInt(g_pa)){
                sum_pa_2.setTextColor(Color.GREEN);
            }
            //March
            json_data = jArray.getJSONObject(2);

            g_rt = json_data.getString("g_rt");
            g_pa = json_data.getString("g_pa");
            e_rt = json_data.getString("e_rt");
            e_pa = json_data.getString("e_pa");

            TextView sum_rt_3 = (TextView) getView().findViewById(R.id.sum_rt_3);
            sum_rt_3.setText(g_rt + "/" + g_pa);
            TextView sum_pa_3 = (TextView) getView().findViewById(R.id.sum_pa_3);
            sum_pa_3.setText(e_rt + "/" + e_pa);
            if (Integer.parseInt(e_rt) < Integer.parseInt(g_rt) && Integer.parseInt(e_pa) < Integer.parseInt(g_pa)){
                sum_pa_3.setTextColor(Color.RED);
            }else if (Integer.parseInt(e_rt) < Integer.parseInt(g_rt) || Integer.parseInt(e_pa) < Integer.parseInt(g_pa)) {
                sum_pa_3.setTextColor(Color.parseColor("#FFA500"));
            }else if (Integer.parseInt(e_rt) > Integer.parseInt(g_rt) && Integer.parseInt(e_pa) > Integer.parseInt(g_pa)){
                sum_pa_3.setTextColor(Color.GREEN);
            }
            //April
            json_data = jArray.getJSONObject(3);

            g_rt = json_data.getString("g_rt");
            g_pa = json_data.getString("g_pa");
            e_rt = json_data.getString("e_rt");
            e_pa = json_data.getString("e_pa");

            TextView sum_rt_4 = (TextView) getView().findViewById(R.id.sum_rt_4);
            sum_rt_4.setText(g_rt + "/" + g_pa);
            TextView sum_pa_4 = (TextView) getView().findViewById(R.id.sum_pa_4);
            sum_pa_4.setText(e_rt + "/" + e_pa);
            if (Integer.parseInt(e_rt) < Integer.parseInt(g_rt) && Integer.parseInt(e_pa) < Integer.parseInt(g_pa)){
                sum_pa_4.setTextColor(Color.RED);
            }else if (Integer.parseInt(e_rt) < Integer.parseInt(g_rt) || Integer.parseInt(e_pa) < Integer.parseInt(g_pa)) {
                sum_pa_4.setTextColor(Color.parseColor("#FFA500"));
            }else if (Integer.parseInt(e_rt) > Integer.parseInt(g_rt) && Integer.parseInt(e_pa) > Integer.parseInt(g_pa)){
                sum_pa_4.setTextColor(Color.GREEN);
            }
            //May
            json_data = jArray.getJSONObject(4);

            g_rt = json_data.getString("g_rt");
            g_pa = json_data.getString("g_pa");
            e_rt = json_data.getString("e_rt");
            e_pa = json_data.getString("e_pa");

            TextView sum_rt_5 = (TextView) getView().findViewById(R.id.sum_rt_5);
            sum_rt_5.setText(g_rt + "/" + g_pa);
            TextView sum_pa_5 = (TextView) getView().findViewById(R.id.sum_pa_5);
            sum_pa_5.setText(e_rt + "/" + e_pa);
            if (Integer.parseInt(e_rt) < Integer.parseInt(g_rt) && Integer.parseInt(e_pa) < Integer.parseInt(g_pa)){
                sum_pa_5.setTextColor(Color.RED);
            }else if (Integer.parseInt(e_rt) < Integer.parseInt(g_rt) || Integer.parseInt(e_pa) < Integer.parseInt(g_pa)) {
                sum_pa_5.setTextColor(Color.parseColor("#FFA500"));
            }else if (Integer.parseInt(e_rt) > Integer.parseInt(g_rt) && Integer.parseInt(e_pa) > Integer.parseInt(g_pa)){
                sum_pa_5.setTextColor(Color.GREEN);
            }
            //June
            json_data = jArray.getJSONObject(5);

            g_rt = json_data.getString("g_rt");
            g_pa = json_data.getString("g_pa");
            e_rt = json_data.getString("e_rt");
            e_pa = json_data.getString("e_pa");

            TextView sum_rt_6 = (TextView) getView().findViewById(R.id.sum_rt_6);
            sum_rt_6.setText(g_rt + "/" + g_pa);
            TextView sum_pa_6 = (TextView) getView().findViewById(R.id.sum_pa_6);
            sum_pa_6.setText(e_rt + "/" + e_pa);
            if (Integer.parseInt(e_rt) < Integer.parseInt(g_rt) && Integer.parseInt(e_pa) < Integer.parseInt(g_pa)){
                sum_pa_6.setTextColor(Color.RED);
            }else if (Integer.parseInt(e_rt) < Integer.parseInt(g_rt) || Integer.parseInt(e_pa) < Integer.parseInt(g_pa)) {
                sum_pa_6.setTextColor(Color.parseColor("#FFA500"));
            }else if (Integer.parseInt(e_rt) > Integer.parseInt(g_rt) && Integer.parseInt(e_pa) > Integer.parseInt(g_pa)){
                sum_pa_6.setTextColor(Color.GREEN);
            }
            //July
            json_data = jArray.getJSONObject(6);

            g_rt = json_data.getString("g_rt");
            g_pa = json_data.getString("g_pa");
            e_rt = json_data.getString("e_rt");
            e_pa = json_data.getString("e_pa");

            TextView sum_rt_7 = (TextView) getView().findViewById(R.id.sum_rt_7);
            sum_rt_7.setText(g_rt + "/" + g_pa);
            TextView sum_pa_7 = (TextView) getView().findViewById(R.id.sum_pa_7);
            sum_pa_7.setText(e_rt + "/" + e_pa);
            if (Integer.parseInt(e_rt) < Integer.parseInt(g_rt) && Integer.parseInt(e_pa) < Integer.parseInt(g_pa)){
                sum_pa_7.setTextColor(Color.RED);
            }else if (Integer.parseInt(e_rt) < Integer.parseInt(g_rt) || Integer.parseInt(e_pa) < Integer.parseInt(g_pa)) {
                sum_pa_7.setTextColor(Color.parseColor("#FFA500"));
            }else if (Integer.parseInt(e_rt) > Integer.parseInt(g_rt) && Integer.parseInt(e_pa) > Integer.parseInt(g_pa)){
                sum_pa_7.setTextColor(Color.GREEN);
            }
            //August
            json_data = jArray.getJSONObject(7);

            g_rt = json_data.getString("g_rt");
            g_pa = json_data.getString("g_pa");
            e_rt = json_data.getString("e_rt");
            e_pa = json_data.getString("e_pa");

            TextView sum_rt_8 = (TextView) getView().findViewById(R.id.sum_rt_8);
            sum_rt_8.setText(g_rt + "/" + g_pa);
            TextView sum_pa_8 = (TextView) getView().findViewById(R.id.sum_pa_8);
            sum_pa_8.setText(e_rt + "/" + e_pa);
            if (Integer.parseInt(e_rt) < Integer.parseInt(g_rt) && Integer.parseInt(e_pa) < Integer.parseInt(g_pa)){
                sum_pa_8.setTextColor(Color.RED);
            }else if (Integer.parseInt(e_rt) < Integer.parseInt(g_rt) || Integer.parseInt(e_pa) < Integer.parseInt(g_pa)) {
                sum_pa_8.setTextColor(Color.parseColor("#FFA500"));
            }else if (Integer.parseInt(e_rt) > Integer.parseInt(g_rt) && Integer.parseInt(e_pa) > Integer.parseInt(g_pa)){
                sum_pa_8.setTextColor(Color.GREEN);
            }
            //September
            json_data = jArray.getJSONObject(8);

            g_rt = json_data.getString("g_rt");
            g_pa = json_data.getString("g_pa");
            e_rt = json_data.getString("e_rt");
            e_pa = json_data.getString("e_pa");

            TextView sum_rt_9 = (TextView) getView().findViewById(R.id.sum_rt_9);
            sum_rt_9.setText(g_rt + "/" + g_pa);
            TextView sum_pa_9 = (TextView) getView().findViewById(R.id.sum_pa_9);
            sum_pa_9.setText(e_rt + "/" + e_pa);
            if (Integer.parseInt(e_rt) < Integer.parseInt(g_rt) && Integer.parseInt(e_pa) < Integer.parseInt(g_pa)){
                sum_pa_9.setTextColor(Color.RED);
            }else if (Integer.parseInt(e_rt) < Integer.parseInt(g_rt) || Integer.parseInt(e_pa) < Integer.parseInt(g_pa)) {
                sum_pa_9.setTextColor(Color.parseColor("#FFA500"));
            }else if (Integer.parseInt(e_rt) > Integer.parseInt(g_rt) && Integer.parseInt(e_pa) > Integer.parseInt(g_pa)){
                sum_pa_9.setTextColor(Color.GREEN);
            }
            //October
            json_data = jArray.getJSONObject(9);

            g_rt = json_data.getString("g_rt");
            g_pa = json_data.getString("g_pa");
            e_rt = json_data.getString("e_rt");
            e_pa = json_data.getString("e_pa");

            TextView sum_rt_10 = (TextView) getView().findViewById(R.id.sum_rt_10);
            sum_rt_10.setText(g_rt + "/" + g_pa);
            TextView sum_pa_10 = (TextView) getView().findViewById(R.id.sum_pa_10);
            sum_pa_10.setText(e_rt + "/" + e_pa);
            if (Integer.parseInt(e_rt) < Integer.parseInt(g_rt) && Integer.parseInt(e_pa) < Integer.parseInt(g_pa)){
                sum_pa_10.setTextColor(Color.RED);
            }else if (Integer.parseInt(e_rt) < Integer.parseInt(g_rt) || Integer.parseInt(e_pa) < Integer.parseInt(g_pa)) {
                sum_pa_10.setTextColor(Color.parseColor("#FFA500"));
            }else if (Integer.parseInt(e_rt) > Integer.parseInt(g_rt) && Integer.parseInt(e_pa) > Integer.parseInt(g_pa)){
                sum_pa_10.setTextColor(Color.GREEN);
            }
            //Noverber
            json_data = jArray.getJSONObject(10);

            g_rt = json_data.getString("g_rt");
            g_pa = json_data.getString("g_pa");
            e_rt = json_data.getString("e_rt");
            e_pa = json_data.getString("e_pa");

            TextView sum_rt_11 = (TextView) getView().findViewById(R.id.sum_rt_11);
            sum_rt_11.setText(g_rt + "/" + g_pa);
            TextView sum_pa_11 = (TextView) getView().findViewById(R.id.sum_pa_11);
            sum_pa_11.setText(e_rt + "/" + e_pa);
            if (Integer.parseInt(e_rt) < Integer.parseInt(g_rt) && Integer.parseInt(e_pa) < Integer.parseInt(g_pa)){
                sum_pa_11.setTextColor(Color.RED);
            }else if (Integer.parseInt(e_rt) < Integer.parseInt(g_rt) || Integer.parseInt(e_pa) < Integer.parseInt(g_pa)) {
                sum_pa_11.setTextColor(Color.parseColor("#FFA500"));
            }else if (Integer.parseInt(e_rt) > Integer.parseInt(g_rt) && Integer.parseInt(e_pa) > Integer.parseInt(g_pa)){
                sum_pa_11.setTextColor(Color.GREEN);
            }
            //December
            json_data = jArray.getJSONObject(11);

            g_rt = json_data.getString("g_rt");
            g_pa = json_data.getString("g_pa");
            e_rt = json_data.getString("e_rt");
            e_pa = json_data.getString("e_pa");

            TextView sum_rt_12 = (TextView) getView().findViewById(R.id.sum_rt_12);
            sum_rt_12.setText(g_rt + "/" + g_pa);
            TextView sum_pa_12 = (TextView) getView().findViewById(R.id.sum_pa_12);
            sum_pa_12.setText(e_rt + "/" + e_pa);
            if (Integer.parseInt(e_rt) < Integer.parseInt(g_rt) && Integer.parseInt(e_pa) < Integer.parseInt(g_pa)){
                sum_pa_12.setTextColor(Color.RED);
            }else if (Integer.parseInt(e_rt) < Integer.parseInt(g_rt) || Integer.parseInt(e_pa) < Integer.parseInt(g_pa)) {
                sum_pa_12.setTextColor(Color.parseColor("#FFA500"));
            }else if (Integer.parseInt(e_rt) > Integer.parseInt(g_rt) && Integer.parseInt(e_pa) > Integer.parseInt(g_pa)){
                sum_pa_12.setTextColor(Color.GREEN);
            }
        } catch (JSONException e) {
            e.printStackTrace();
        }
    }

}

