package net.vision_design.loginapp;

import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.content.Intent;
import android.os.AsyncTask;
import android.preference.PreferenceManager;
import android.support.v4.app.Fragment;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.Gravity;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import android.content.SharedPreferences;
import android.os.Bundle;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.util.Calendar;
import java.util.Iterator;

public class SecondFragment extends Fragment{
    int current_year = 0;
    static int year = 0;  // used to track year with previous/next button
    int user_id;
    JSONArray jArray = null;
    String g_url = "http://xelf.ca/registration/getGoal.php";

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {

        View rootView = inflater.inflate(R.layout.second_fragment, container, false);

        Button submit = (Button) rootView.findViewById(R.id.set_goal_button);
        submit.setOnClickListener(set_goal_Listener);

        Button previous = (Button) rootView.findViewById(R.id.previous);
        previous.setOnClickListener(previous_Listener);

        Button next = (Button) rootView.findViewById(R.id.next);
        next.setOnClickListener(next_Listener);

        return rootView;
    }

    @Override
    public void onActivityCreated(Bundle savedInstanceState) {
        super.onActivityCreated(savedInstanceState);

        //final GlobalUserid globalUserid = (GlobalUserid) getActivity().getApplicationContext();
        //user_id  = globalUserid.getUserid();
        user_id = Integer.parseInt(SaveSharedPreference.getUserId(SecondFragment.super.getContext()));

        Calendar now = Calendar.getInstance();
        year = now.get(Calendar.YEAR);
        current_year = year;

        EditText y = (EditText) getView().findViewById(R.id.year);
        CharSequence yearcs = Integer.toString(year);
        y.setText(yearcs);

        GetGoal getGoal = new GetGoal();
        String r = "Hello";
        try {
            r = getGoal.execute(g_url, String.valueOf(user_id), String.valueOf(year)).get();
        }catch (Exception e){

        }
        setGoalValues(r, String.valueOf(year));
       // Toast.makeText(getContext().getApplicationContext(), "", Toast.LENGTH_LONG).show();

    }

    private View.OnClickListener next_Listener = new View.OnClickListener() {
        public void onClick(View v) {
            year++;
            Fragment sf = new SecondFragment();
            sf.getView();
            //resetText();

            if (year - current_year == 2) {
                Button next = (Button) getView().findViewById(R.id.next);
                next.setEnabled(false);
            }
            if (current_year - year < 2) {
                Button previous = (Button) getView().findViewById(R.id.previous);
                previous.setEnabled(true);
            }

            EditText y = (EditText) getView().findViewById(R.id.year);
            CharSequence yearcs = Integer.toString(year);
            y.setText(yearcs);
            GetGoal getGoal = new GetGoal();
            String r = "Hello";
            try {
                r = getGoal.execute(g_url, String.valueOf(user_id), String.valueOf(year)).get();
            }catch (Exception e){

            }
            setGoalValues(r, String.valueOf(year));
          //  Toast.makeText(getContext().getApplicationContext(), String.valueOf(year), Toast.LENGTH_LONG).show();
        }
    };

    private View.OnClickListener previous_Listener = new View.OnClickListener() {
        public void onClick(View v) {
            year--;
            Fragment sf = new SecondFragment();
            sf.getView();
            //resetText();

            if (current_year - year == 2) {
                Button previous = (Button) getView().findViewById(R.id.previous);
                previous.setEnabled(false);
            }
            if (year - current_year < 2) {
                Button next = (Button) getView().findViewById(R.id.next);
                next.setEnabled(true);
            }

            EditText y = (EditText) getView().findViewById(R.id.year);
            CharSequence yearcs = Integer.toString(year);
            y.setText(yearcs);
            GetGoal getGoal = new GetGoal();
            String r = "Hello";
            try {
                r = getGoal.execute(g_url, String.valueOf(user_id), String.valueOf(year)).get();
            }catch (Exception e){

            }
            setGoalValues(r, String.valueOf(year));
          //  Toast.makeText(getContext().getApplicationContext(), String.valueOf(year), Toast.LENGTH_LONG).show();
        }
    };

    private View.OnClickListener set_goal_Listener = new View.OnClickListener() {
        //public void update_profile(View view) throws Exception{
        public void onClick(View v) {
            EditText rt1 = (EditText) getView().findViewById(R.id.rt_1);
            String rt_1 = rt1.getText().toString();
            EditText rt2 = (EditText) getView().findViewById(R.id.rt_2);
            String rt_2 = rt2.getText().toString();
            EditText rt3 = (EditText) getView().findViewById(R.id.rt_3);
            String rt_3 = rt3.getText().toString();
            EditText rt4 = (EditText) getView().findViewById(R.id.rt_4);
            String rt_4 = rt4.getText().toString();
            EditText rt5 = (EditText) getView().findViewById(R.id.rt_5);
            String rt_5 = rt5.getText().toString();
            EditText rt6 = (EditText) getView().findViewById(R.id.rt_6);
            String rt_6 = rt6.getText().toString();
            EditText rt7 = (EditText) getView().findViewById(R.id.rt_7);
            String rt_7 = rt7.getText().toString();
            EditText rt8 = (EditText) getView().findViewById(R.id.rt_8);
            String rt_8 = rt8.getText().toString();
            EditText rt9 = (EditText) getView().findViewById(R.id.rt_9);
            String rt_9 = rt9.getText().toString();
            EditText rt10 = (EditText) getView().findViewById(R.id.rt_10);
            String rt_10 = rt10.getText().toString();
            EditText rt11 = (EditText) getView().findViewById(R.id.rt_11);
            String rt_11 = rt11.getText().toString();
            EditText rt12 = (EditText) getView().findViewById(R.id.rt_12);
            String rt_12 = rt12.getText().toString();

            EditText pa1 = (EditText) getView().findViewById(R.id.pa_1);
            String pa_1 = pa1.getText().toString();
            EditText pa2 = (EditText) getView().findViewById(R.id.pa_2);
            String pa_2 = pa2.getText().toString();
            EditText pa3 = (EditText) getView().findViewById(R.id.pa_3);
            String pa_3 = pa3.getText().toString();
            EditText pa4 = (EditText) getView().findViewById(R.id.pa_4);
            String pa_4 = pa4.getText().toString();
            EditText pa5 = (EditText) getView().findViewById(R.id.pa_5);
            String pa_5 = pa5.getText().toString();
            EditText pa6 = (EditText) getView().findViewById(R.id.pa_6);
            String pa_6 = pa6.getText().toString();
            EditText pa7 = (EditText) getView().findViewById(R.id.pa_7);
            String pa_7 = pa7.getText().toString();
            EditText pa8 = (EditText) getView().findViewById(R.id.pa_8);
            String pa_8 = pa8.getText().toString();
            EditText pa9 = (EditText) getView().findViewById(R.id.pa_9);
            String pa_9 = pa9.getText().toString();
            EditText pa10 = (EditText) getView().findViewById(R.id.pa_10);
            String pa_10 = pa10.getText().toString();
            EditText pa11 = (EditText) getView().findViewById(R.id.pa_11);
            String pa_11 = pa11.getText().toString();
            EditText pa12 = (EditText) getView().findViewById(R.id.pa_12);
            String pa_12 = pa12.getText().toString();

           /* Toast.makeText(getApplicationContext(), userid,
                    Toast.LENGTH_LONG).show();*/
            String uyear = String.valueOf(year);
            String userid = String.valueOf(user_id);
            String url = "http://xelf.ca/registration/setGoal.php";
            SetGoal setGoal = new SetGoal();
            String r = "";
            try {
                r = setGoal.execute(url, userid, uyear, rt_1, rt_2, rt_3, rt_4, rt_5, rt_6, rt_7, rt_8, rt_9, rt_10, rt_11, rt_12,
                        pa_1, pa_2, pa_3, pa_4, pa_5, pa_6, pa_7, pa_8, pa_9, pa_10, pa_11, pa_12).get();
            }catch (Exception e){
                ;
            }
            Toast.makeText(getActivity().getApplicationContext(), r, Toast.LENGTH_LONG).show();
        }
    };

    //send post method which will be called from loginClicked method
//    private String sendPost(String url, String urlParameters) throws Exception {
    public class SetGoal extends AsyncTask<String, Void, String> {

        protected void onPreExecute() {
        }

        @Override
        protected String doInBackground(String... params) {
            try {
                URL url = new URL(params[0]);
                JSONObject postDataParams = new JSONObject();
                postDataParams.put("user_id", params[1]);
                postDataParams.put("year", params[2]);
                postDataParams.put("rt_1", params[3]);
                postDataParams.put("rt_2", params[4]);
                postDataParams.put("rt_3", params[5]);
                postDataParams.put("rt_4", params[6]);
                postDataParams.put("rt_5", params[7]);
                postDataParams.put("rt_6", params[8]);
                postDataParams.put("rt_7", params[9]);
                postDataParams.put("rt_8", params[10]);
                postDataParams.put("rt_9", params[11]);
                postDataParams.put("rt_10", params[12]);
                postDataParams.put("rt_11", params[13]);
                postDataParams.put("rt_12", params[14]);

                postDataParams.put("pa_1", params[15]);
                postDataParams.put("pa_2", params[16]);
                postDataParams.put("pa_3", params[17]);
                postDataParams.put("pa_4", params[18]);
                postDataParams.put("pa_5", params[19]);
                postDataParams.put("pa_6", params[20]);
                postDataParams.put("pa_7", params[21]);
                postDataParams.put("pa_8", params[22]);
                postDataParams.put("pa_9", params[23]);
                postDataParams.put("pa_10", params[24]);
                postDataParams.put("pa_11", params[25]);
                postDataParams.put("pa_12", params[26]);

                Log.e("params", postDataParams.toString());

                HttpURLConnection conn = (HttpURLConnection) url.openConnection();
                conn.setReadTimeout(3500);
                conn.setConnectTimeout(3500);
                conn.setRequestMethod("POST");
                conn.setDoInput(true);
                conn.setDoOutput(true);

                OutputStream os = conn.getOutputStream();
                BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(os, "UTF-8"));
                writer.write(getPostDataString(postDataParams));

                writer.flush();
                writer.close();
                os.close();

                int responseCode = conn.getResponseCode();

                if (responseCode == HttpURLConnection.HTTP_OK) {

                    BufferedReader in = new BufferedReader(
                            new InputStreamReader(
                                    conn.getInputStream()));
                    StringBuffer sb = new StringBuffer("");
                    String line = "";

                    while ((line = in.readLine()) != null) {

                        sb.append(line);
                        break;
                    }

                    in.close();
                    return sb.toString();

                } else {
                    return new String("false : " + responseCode);
                }
            } catch (Exception e) {
                return new String("Exception: " + e.getMessage());
            }

        }

        @Override
        protected void onPostExecute(String result) {

        }

        public String getPostDataString(JSONObject params) throws Exception {

            StringBuilder result = new StringBuilder();
            boolean first = true;

            Iterator<String> itr = params.keys();

            while (itr.hasNext()) {

                String key = itr.next();
                Object value = params.get(key);

                if (first)
                    first = false;
                else
                    result.append("&");

                result.append(URLEncoder.encode(key, "UTF-8"));
                result.append("=");
                result.append(URLEncoder.encode(value.toString(), "UTF-8"));

            }
            return result.toString();
        }
    }

   public class GetGoal extends AsyncTask<String, Void, String> {

       protected void onPreExecute() {
       }

       @Override
       protected String doInBackground(String... params) {
           try {
               URL url = new URL(params[0]);
               JSONObject postDataParams = new JSONObject();
               postDataParams.put("userid", params[1]);
               postDataParams.put("year", params[2]);
               Log.e("params", postDataParams.toString());

               HttpURLConnection conn = (HttpURLConnection) url.openConnection();
               conn.setReadTimeout(3500);
               conn.setConnectTimeout(3500);  /* milliseconds */
               conn.setRequestMethod("POST");
               conn.setDoInput(true);
               conn.setDoOutput(true);

               OutputStream os = conn.getOutputStream();
               BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(os, "UTF-8"));
               writer.write(getPostDataString(postDataParams));

               writer.flush();
               writer.close();
               os.close();

               int responseCode = conn.getResponseCode();

               if (responseCode == HttpURLConnection.HTTP_OK) {

                   BufferedReader in = new BufferedReader(
                           new InputStreamReader(
                                   conn.getInputStream()));
                   StringBuffer sb = new StringBuffer("");
                   String line = "";

                   while ((line = in.readLine()) != null) {

                       sb.append(line);
                       break;
                   }

                   in.close();
                   return sb.toString();

               } else {
                   return new String("false : " + responseCode);
               }
           } catch (Exception e) {
               return new String("Exception: " + e.getMessage());
           }

       }

       @Override
       protected void onPostExecute(String result) {

       }

       public String getPostDataString(JSONObject params) throws Exception {

           StringBuilder result = new StringBuilder();
           boolean first = true;

           Iterator<String> itr = params.keys();

           while (itr.hasNext()) {

               String key = itr.next();
               Object value = params.get(key);

               if (first)
                   first = false;
               else
                   result.append("&");

               result.append(URLEncoder.encode(key, "UTF-8"));
               result.append("=");
               result.append(URLEncoder.encode(value.toString(), "UTF-8"));

           }
           return result.toString();
       }
   }

    public void setGoalValues(String r, String year){
        JSONObject jsonObj = null;
        try {
            EditText goal_year = (EditText) getView().findViewById(R.id.year);
            goal_year.setText(year);

            jsonObj = new JSONObject(r);
            jArray = jsonObj.getJSONArray("result");
            //January
            JSONObject json_data = jArray.getJSONObject(0);

            String rt = json_data.getString("rt");
            String pa = json_data.getString("pa");

            TextView g_rt_1 = (TextView) getView().findViewById(R.id.rt_1);
            g_rt_1.setText(rt);
            TextView g_pa_1 = (TextView) getView().findViewById(R.id.pa_1);
            g_pa_1.setText(pa);
            //Feburary
            json_data = jArray.getJSONObject(1);

            rt = json_data.getString("rt");
            pa = json_data.getString("pa");

            TextView g_rt_2 = (TextView) getView().findViewById(R.id.rt_2);
            g_rt_2.setText(rt);
            TextView g_pa_2 = (TextView) getView().findViewById(R.id.pa_2);
            g_pa_2.setText(pa);
            //March
            json_data = jArray.getJSONObject(2);

            rt = json_data.getString("rt");
            pa = json_data.getString("pa");

            TextView g_rt_3 = (TextView) getView().findViewById(R.id.rt_3);
            g_rt_3.setText(rt);
            TextView g_pa_3 = (TextView) getView().findViewById(R.id.pa_3);
            g_pa_3.setText(pa);
            //April
            json_data = jArray.getJSONObject(3);

            rt = json_data.getString("rt");
            pa = json_data.getString("pa");

            TextView g_rt_4 = (TextView) getView().findViewById(R.id.rt_4);
            g_rt_4.setText(rt);
            TextView g_pa_4 = (TextView) getView().findViewById(R.id.pa_4);
            g_pa_4.setText(pa);
            //May
            json_data = jArray.getJSONObject(4);

            rt = json_data.getString("rt");
            pa = json_data.getString("pa");

            TextView g_rt_5 = (TextView) getView().findViewById(R.id.rt_5);
            g_rt_5.setText(rt);
            TextView g_pa_5 = (TextView) getView().findViewById(R.id.pa_5);
            g_pa_5.setText(pa);
            //June
            json_data = jArray.getJSONObject(5);

            rt = json_data.getString("rt");
            pa = json_data.getString("pa");

            TextView g_rt_6 = (TextView) getView().findViewById(R.id.rt_6);
            g_rt_6.setText(rt);
            TextView g_pa_6 = (TextView) getView().findViewById(R.id.pa_6);
            g_pa_6.setText(pa);
            //July
            json_data = jArray.getJSONObject(6);

            rt = json_data.getString("rt");
            pa = json_data.getString("pa");

            TextView g_rt_7 = (TextView) getView().findViewById(R.id.rt_7);
            g_rt_7.setText(rt);
            TextView g_pa_7 = (TextView) getView().findViewById(R.id.pa_7);
            g_pa_7.setText(pa);
            //August
            json_data = jArray.getJSONObject(7);

            rt = json_data.getString("rt");
            pa = json_data.getString("pa");

            TextView g_rt_8 = (TextView) getView().findViewById(R.id.rt_8);
            g_rt_8.setText(rt);
            TextView g_pa_8 = (TextView) getView().findViewById(R.id.pa_8);
            g_pa_8.setText(pa);
            //September
            json_data = jArray.getJSONObject(8);

            rt = json_data.getString("rt");
            pa = json_data.getString("pa");

            TextView g_rt_9 = (TextView) getView().findViewById(R.id.rt_9);
            g_rt_9.setText(rt);
            TextView g_pa_9 = (TextView) getView().findViewById(R.id.pa_9);
            g_pa_9.setText(pa);
            //October
            json_data = jArray.getJSONObject(9);

            rt = json_data.getString("rt");
            pa = json_data.getString("pa");

            TextView g_rt_10 = (TextView) getView().findViewById(R.id.rt_10);
            g_rt_10.setText(rt);
            TextView g_pa_10 = (TextView) getView().findViewById(R.id.pa_10);
            g_pa_10.setText(pa);
            //November
            json_data = jArray.getJSONObject(10);

            rt = json_data.getString("rt");
            pa = json_data.getString("pa");

            TextView g_rt_11 = (TextView) getView().findViewById(R.id.rt_11);
            g_rt_11.setText(rt);
            TextView g_pa_11 = (TextView) getView().findViewById(R.id.pa_11);
            g_pa_11.setText(pa);
            //December
            json_data = jArray.getJSONObject(11);

            rt = json_data.getString("rt");
            pa = json_data.getString("pa");

            TextView g_rt_12 = (TextView) getView().findViewById(R.id.rt_12);
            g_rt_12.setText(rt);
            TextView g_pa_12 = (TextView) getView().findViewById(R.id.pa_12);
            g_pa_12.setText(pa);
        } catch (JSONException e) {
            e.printStackTrace();
        }
    }
}

