package net.vision_design.loginapp;

import android.content.Context;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.Toast;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.Iterator;

/**
 * Created by Owner on 2/15/2017.
 */

public class ShareFragment extends Fragment {
    //String commentJSON;
    private ListView mListView;

    int user_id;
    ArrayList<Comments> commentList = null;

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {

        View rootView = inflater.inflate(R.layout.share_fragment, container, false);

        Button submit = (Button) rootView.findViewById(R.id.share_button);
        submit.setOnClickListener(submit_comment);
        //mListView = (ListView) getActivity().findViewById(R.id.comment_list);
        mListView = (ListView) rootView.findViewById(R.id.comment_list);
        return rootView;
    }

    @Override
    public void onActivityCreated(Bundle savedInstanceState) {
        super.onActivityCreated(savedInstanceState);

        //user_id = SaveSharedPreference.getUserId(ShareFragment.super.getContext());

        //final GlobalUserid globalUserid = (GlobalUserid) getActivity().getApplicationContext();
        //final int user_id  = globalUserid.getUserid();
        user_id = Integer.parseInt(SaveSharedPreference.getUserId(ShareFragment.super.getContext()));
        //Comments comments = new Comments();
        commentList = getComments(user_id, getActivity());

     /*   int l = commentList.size();
        Comments c = commentList.get(0);
        String content = c.comment_content;
        Toast.makeText(getContext().getApplicationContext(), "ggg grg " + content,
                Toast.LENGTH_SHORT).show();
    */
        if (!commentList.isEmpty()) {
            CommentListAdapter adapter = new CommentListAdapter(getActivity(), commentList);
            mListView.setAdapter(adapter);
        }
    }

    private View.OnClickListener submit_comment = new View.OnClickListener() {
        //public void update_profile(View view) throws Exception{
        public void onClick(View v) {
            EditText cm = (EditText) getView().findViewById(R.id.comment);
            String newcComment = cm.getText().toString();


           /* Toast.makeText(getApplicationContext(), userid,
                    Toast.LENGTH_LONG).show();*/
            String url = "http://xelf.ca/registration/setShare.php";
            ShareFragment.SubmitComment submitComment = new ShareFragment.SubmitComment();
            //String r = "";
            try {
                submitComment.execute(url, String.valueOf(user_id), newcComment).get();
                Toast.makeText(getActivity().getApplicationContext(), "Comment saved.", Toast.LENGTH_LONG).show();
                cm.setText("");
                //update comment in listview
               // Comments comments = new Comments();
                commentList = getComments(user_id, getActivity());
                CommentListAdapter adapter = new CommentListAdapter(getActivity(), commentList);
                mListView.setAdapter(adapter);
            }catch (Exception e){
                ;
            }

        }
    };

    public class SubmitComment extends AsyncTask<String, Void, String> {

        protected void onPreExecute() {
        }

        @Override
        protected String doInBackground(String... params) {
            try {
                URL url = new URL(params[0]);
                JSONObject postDataParams = new JSONObject();
                postDataParams.put("user_id", params[1]);
                postDataParams.put("comment_content", params[2]);
                Log.e("params", postDataParams.toString());

                HttpURLConnection conn = (HttpURLConnection) url.openConnection();
                conn.setReadTimeout(3500);
                conn.setConnectTimeout(3500);  /* milliseconds */
                conn.setRequestMethod("POST");
                conn.setDoInput(true);
                conn.setDoOutput(true);

                OutputStream os = conn.getOutputStream();
                BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(os, "UTF-8"));
                writer.write(getPostDataString(postDataParams));

                writer.flush();
                writer.close();
                os.close();

                int responseCode = conn.getResponseCode();

                if (responseCode == HttpURLConnection.HTTP_OK) {

                    BufferedReader in = new BufferedReader(
                            new InputStreamReader(
                                    conn.getInputStream()));
                    StringBuffer sb = new StringBuffer("");
                    String line = "";

                    while ((line = in.readLine()) != null) {

                        sb.append(line);
                        break;
                    }

                    in.close();
                    return sb.toString();

                } else {
                    return new String("false : " + responseCode);
                }
            } catch (Exception e) {
                return new String("Exception: " + e.getMessage());
            }

        }

        @Override
        protected void onPostExecute(String result) {

        }

        public String getPostDataString(JSONObject params) throws Exception {

            StringBuilder result = new StringBuilder();
            boolean first = true;

            Iterator<String> itr = params.keys();

            while (itr.hasNext()) {

                String key = itr.next();
                Object value = params.get(key);

                if (first)
                    first = false;
                else
                    result.append("&");

                result.append(URLEncoder.encode(key, "UTF-8"));
                result.append("=");
                result.append(URLEncoder.encode(value.toString(), "UTF-8"));

            }
            return result.toString();
        }
    }

    public ArrayList<Comments> getComments(int user_id, Context context){
        final ArrayList<Comments> commentList = new ArrayList<Comments>();

        String url = "http://xelf.ca/registration/getShare.php";

        try {
            // Load data
            GetUserComment userComment = new GetUserComment(user_id, url);
            String jsonString = null;
            try {
                jsonString = userComment.execute().get();
            }catch (Exception e){

            }

            JSONObject json;
            JSONArray comments;
            //try {
            json = new JSONObject(jsonString);
            comments = json.getJSONArray("comments");
            //}catch(JSONException e){
            //    e.printStackTrace();
            //}
            // Get Recipe objects from data
            if (comments != null && comments.length() > 0) {
                for (int i = 0; i < comments.length(); i++) {

                    Comments comment = new Comments();

                    comment.comment_content = comments.getJSONObject(i).getString("comment_content");
                    comment.comment_date = comments.getJSONObject(i).getString("comment_date");


                    commentList.add(comment);
                }
            }
        } catch (JSONException e) {
            e.printStackTrace();
        }

        return commentList;
    }

    public class GetUserComment extends AsyncTask<Void, Void, String> {
        int intValue;
        String strValue;

        public GetUserComment(int intValue,String strValue){
            this.intValue = intValue;
            this.strValue = strValue;
        }

        protected void onPreExecute() {
        }

        @Override
        protected String doInBackground(Void... params) {
            try {
                URL url = new URL(strValue);
                JSONObject postDataParams = new JSONObject();
                postDataParams.put("user_id", intValue);
                Log.e("params", postDataParams.toString());

                HttpURLConnection conn = (HttpURLConnection) url.openConnection();
                conn.setReadTimeout(3500);
                conn.setConnectTimeout(3500);
                conn.setRequestMethod("POST");
                conn.setDoInput(true);
                conn.setDoOutput(true);

                OutputStream os = conn.getOutputStream();
                BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(os, "UTF-8"));
                writer.write(getPostDataString(postDataParams));

                writer.flush();
                writer.close();
                os.close();

                int responseCode = conn.getResponseCode();

                if (responseCode == HttpURLConnection.HTTP_OK) {

                    BufferedReader in = new BufferedReader(
                            new InputStreamReader(
                                    conn.getInputStream()));
                    StringBuffer sb = new StringBuffer("");
                    String line = "";

                    while ((line = in.readLine()) != null) {

                        sb.append(line);
                        break;
                    }

                    in.close();
                    return sb.toString();

                } else {
                    return new String("false : " + responseCode);
                }
            } catch (Exception e) {
                return new String("Exception: " + e.getMessage());
            }

        }

        @Override
        protected void onPostExecute(String result) {

        }

        public String getPostDataString(JSONObject params) throws Exception {

            StringBuilder result = new StringBuilder();
            boolean first = true;

            Iterator<String> itr = params.keys();

            while (itr.hasNext()) {

                String key = itr.next();
                Object value = params.get(key);

                if (first)
                    first = false;
                else
                    result.append("&");

                result.append(URLEncoder.encode(key, "UTF-8"));
                result.append("=");
                result.append(URLEncoder.encode(value.toString(), "UTF-8"));

            }
            return result.toString();
        }
    }

}
